// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Menus.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CComModule _Module;
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DRAWITEM()
	ON_WM_MEASUREITEM()
	ON_WM_SETTINGCHANGE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
// Here we setup QHTML resources for each menu item using tag <TXT>
// We use this approach for three reasons:
// 1. In the MFC library class CString cannot load an HTML resource,
//    and we do not want to write out own procedure to do that.
// 2. Putting lots of HTML right into code won't look good,
//    it is definitely should be in the resources
// 3. Viewing and editing HTML contents in the resource editor
//    is much easier than in the code.
//
// Basically, here we every time use tag <txt> specified to load
// an HTML resource that we need:

	m_ItemNew.SetSourceText(_T("<txt res='html:idr_new'>"));
	m_ItemNewSelected.SetSourceText(_T("<txt res='html:idr_new_selected'>"));

	m_ItemOpen.SetSourceText(_T("<txt res='html:idr_open'>"));
	m_ItemOpenSelected.SetSourceText(_T("<txt res='html:idr_open_selected'>"));

	m_ItemPrint.SetSourceText(_T("<txt res='html:idr_print'>"));
	m_ItemPrintSelected.SetSourceText(_T("<txt res='html:idr_print_selected'>"));

	m_ItemSave.SetSourceText(_T("<txt res='html:idr_save'>"));
	m_ItemSaveSelected.SetSourceText(_T("<txt res='html:idr_save_selected'>"));

	m_ItemPreview.SetSourceText(_T("<txt res='html:idr_preview'>"));
	m_ItemPreviewSelected.SetSourceText(_T("<txt res='html:idr_preview_selected'>"));

	m_ItemExit.SetSourceText(_T("<txt res='html:idr_exit'>"));
	m_ItemExitSelected.SetSourceText(_T("<txt res='html:idr_exit_selected'>"));

	// Telling the tooltip manager to display tooltips just after 0.3
	// second after the mouse cursor stops over a menu item:
	m_tool.ShowDelay = 300;

	// Here we attach a tooltip for each menu item.
	// Note that we use the same contents like for unselected
	// menu items. This indeed will display the same in the tooltips.
	// Author hopes his laziness will be forgiven, for it was done just
	// for simplicity to avoid writing extra HTML resources.
	// In practice, you, of course will have tooltips with a contents
	// different from what is displayed within the menu item.
	m_tool.commands.Add(ID_FILE_NEW, _T("<txt res='html:idr_new'>"));
	m_tool.commands.Add(ID_FILE_OPEN, _T("<txt res='html:idr_open'>"));
	m_tool.commands.Add(ID_FILE_PRINT, _T("<txt res='html:idr_print'>"));
	m_tool.commands.Add(ID_FILE_PRINT_PREVIEW, _T("<txt res='html:idr_preview'>"));
	m_tool.commands.Add(ID_FILE_SAVE, _T("<txt res='html:idr_save'>"));

	// Actually, this one will also attach the tooltip to the Exit
	// button on the toolbar, since they have the same command ID:
	m_tool.commands.Add(ID_APP_EXIT, _T("<txt res='html:idr_exit'>"));
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	// be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// ********************************************************************
	// *** Modifying menu items in the "File" menu to be ownerdrawn:
	// ********************************************************************
	UINT MenuItems[] = {ID_FILE_NEW, ID_FILE_OPEN, ID_FILE_PRINT, ID_FILE_SAVE,
						ID_FILE_PRINT_PREVIEW, ID_APP_EXIT};
	HMENU hMenu = *GetMenu()->GetSubMenu(0); // Retrieving the "File" pop-up menu
	MENUITEMINFO mi;
	mi.cbSize = sizeof(MENUITEMINFO);
	mi.fMask = MIIM_TYPE;
	mi.fType = MFT_OWNERDRAW;
	// Making all items ownerdrawn:
	for(int i = 0;i < sizeof(MenuItems) / sizeof(UINT);i ++)
		SetMenuItemInfo(hMenu, MenuItems[i], FALSE, &mi);
	// *********************************************************************

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	if(lpMeasureItemStruct->CtlType == ODT_MENU)
		switch(lpMeasureItemStruct->itemID)
		{
		case ID_FILE_NEW:
			{
				lpMeasureItemStruct->itemHeight = m_ItemNew.Height;
				lpMeasureItemStruct->itemWidth = m_ItemNew.Width;
				break;
			}
		case ID_FILE_OPEN:
			{
				lpMeasureItemStruct->itemHeight = m_ItemOpen.Height;
				lpMeasureItemStruct->itemWidth = m_ItemOpen.Width;
				break;
			}
		case ID_FILE_PRINT:
			{
				lpMeasureItemStruct->itemHeight = m_ItemPrint.Height;
				lpMeasureItemStruct->itemWidth = m_ItemPrint.Width;
				break;
			}
		case ID_FILE_SAVE:
			{
				lpMeasureItemStruct->itemHeight = m_ItemSave.Height;
				lpMeasureItemStruct->itemWidth = m_ItemSave.Width;
				break;
			}
		case ID_FILE_PRINT_PREVIEW:
			{
				lpMeasureItemStruct->itemHeight = m_ItemPreview.Height;
				lpMeasureItemStruct->itemWidth = m_ItemPreview.Width;
				break;
			}
		case ID_APP_EXIT:
			{
				lpMeasureItemStruct->itemHeight = m_ItemExit.Height;
				lpMeasureItemStruct->itemWidth = m_ItemExit.Width;
				break;
			}
		default:
			break;
		}
	CFrameWnd::OnMeasureItem(nIDCtl, lpMeasureItemStruct);
}

// We use a very straightforward approach to drawing items here,
// and it defenitely can be optimized
void CMainFrame::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	if(lpDrawItemStruct->CtlType == ODT_MENU)
	{
		switch(lpDrawItemStruct->itemID)
		{
		case ID_FILE_NEW:
			{
				DrawItem(m_ItemNew, m_ItemNewSelected, lpDrawItemStruct);
				break;
			}
		case ID_FILE_OPEN:
			{
				DrawItem(m_ItemOpen, m_ItemOpenSelected, lpDrawItemStruct);
				break;
			}
		case ID_FILE_PRINT:
			{
				DrawItem(m_ItemPrint, m_ItemPrintSelected, lpDrawItemStruct);
				break;
			}
		case ID_FILE_SAVE:
			{
				DrawItem(m_ItemSave, m_ItemSaveSelected, lpDrawItemStruct);
				break;
			}
		case ID_FILE_PRINT_PREVIEW:
			{
				DrawItem(m_ItemPreview, m_ItemPreviewSelected, lpDrawItemStruct);
				break;
			}
		case ID_APP_EXIT:
			{
				DrawItem(m_ItemExit, m_ItemExitSelected, lpDrawItemStruct);
				break;
			}
		default:
			break;
		}
	}
	CFrameWnd::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

// When system font or color changes Windows sends event
// WM_SETTINGCHANGE, which we handle here to update appearance
// of all menu items dynamically:
void CMainFrame::OnSettingChange(UINT uFlags, LPCTSTR lpszSection)
{
	CFrameWnd::OnSettingChange(uFlags, lpszSection);
	
	m_ItemNew.RecalculateLayout();
	m_ItemNewSelected.RecalculateLayout();

	m_ItemOpen.RecalculateLayout();
	m_ItemOpenSelected.RecalculateLayout();

	m_ItemSave.RecalculateLayout();
	m_ItemSaveSelected.RecalculateLayout();

	m_ItemPrint.RecalculateLayout();
	m_ItemPrintSelected.RecalculateLayout();

	m_ItemPreview.RecalculateLayout();
	m_ItemPreviewSelected.RecalculateLayout();

	m_ItemExit.RecalculateLayout();
	m_ItemExitSelected.RecalculateLayout();
}

void CMainFrame::DrawItem(CMenuItem & Item, CMenuItem & ItemSel, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	// First, we draw the item's background:
	bool bSelected = (lpDrawItemStruct->itemAction == ODA_SELECT && lpDrawItemStruct->itemState&ODS_SELECTED);
	FillRect(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, GetSysColorBrush(bSelected?COLOR_HIGHLIGHT:COLOR_MENU));

	// Then we draw the item itself by redirecting all the drawing functionality
	// into the Quick HTML parser:
	if(bSelected)
		ItemSel.Draw(lpDrawItemStruct->hDC, (short)lpDrawItemStruct->rcItem.left, (short)lpDrawItemStruct->rcItem.top);
	else
		Item.Draw(lpDrawItemStruct->hDC, (short)lpDrawItemStruct->rcItem.left, (short)lpDrawItemStruct->rcItem.top);
}
